/*
BINARY TREE TASK

Write a program to sort a sequence of numbers using a binary tree (using pointers).
a binary tree is a tree structure with only two (possible) branches from each node.
Each branch then represents a false or true decision.
To sort numbers simply assign the left branch to take numbers
less than the node number and right branch any other number (greater than or equal to).
To obtain a sorted list simply search the tree in a depth first fashion.

Raivo Riiel
142455
MVEB22

25.03.2016
*/
#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#define SIZE 50 //Adjust size of the array from here

struct node{
    int data;
    struct node *left;
    struct node *right;
};
int createArray(int size);//Mallocates memory for array with given SIZE and fills it with random numbers.
void insert(struct node **source, int numberToInsert);//takes numbers from array and inserts them to a binary tree
void display(struct node **source); //displays tree in right order

void main(void){
    int *pointer=createArray(SIZE);
    int *point;
    int counter;
    int numberToInsert;
    struct node *address;
    address=NULL;
    //Creating binary tree
    for(counter=0, point=pointer; counter<SIZE; counter++, point++){
        numberToInsert=*point;
        insert(&address, numberToInsert);
    }
    //Displaying binary tree
    printf("DISPLAYING SORTED ARRAY:\n");
    display(&address);
}

int createArray(int size){
   int *pointer=(int *) malloc(sizeof(int)*SIZE);
   int i;
   int *point;
    printf("\nCREATING %d RANDOM NUMBERS:\n", SIZE);
   for(i=0, point=pointer;i<SIZE;i++,point++){
        *point=rand()%250;//Creates random numbers between 0 and 250
        printf("%d\n", *point);
   }
    return pointer;
}

void insert(struct node **source, int numberToInsert){
    if(*source==NULL){
        *source=malloc(sizeof(struct node));
        (*source)->left=NULL;
        (*source)->right=NULL;
        (*source)->data=numberToInsert;
    }
    else if(numberToInsert<(*source)->data){
        insert(&((*source)->left), numberToInsert);
    }
    else if(numberToInsert>=(*source)->data){
        insert(&((*source)->right), numberToInsert);
    }
}
void display(struct node **source){
    if((*source)->left!=NULL){
        display(&((*source)->left));
    }
    printf("%d\n", (*source)->data);
    if((*source)->right!=NULL){
        display(&((*source)->right));
    }
}
